import { reactive as te, ref as O, computed as ve, toRefs as Be, defineComponent as ge, onMounted as Ce, resolveComponent as m, openBlock as c, createBlock as b, withCtx as a, createElementVNode as Q, renderSlot as R, createVNode as f, unref as e, createElementBlock as $, Fragment as I, renderList as J, mergeProps as M, withModifiers as Pe, createTextVNode as K, toDisplayString as ne, createCommentVNode as N, resolveDirective as Se, withDirectives as ie, createSlots as Te, resolveDynamicComponent as Ne, normalizeProps as ze, guardReactiveProps as Ie, withKeys as Ke, vShow as We, isRef as qe } from "vue";
import { ElMessage as ke, ElMessageBox as Ve, ElNotification as je, ElButton as oe, ElButtonGroup as Qe, ElDialog as Je } from "element-plus";
import { useRoute as Ge } from "vue-router";
const xe = {
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_IsShowMenu: !0,
  Table_MenuWidth: 200,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}, Oe = {
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {}, columns: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
}, Xe = {
  url: "",
  source: {}
};
function Y(p) {
  let d;
  try {
    d = Array.isArray(p) ? [] : {}, p === null && (d = null);
  } catch {
    d = {};
  }
  for (const _ in p)
    typeof p[_] == "object" ? d[_] = Y(p[_]) : d[_] = p[_];
  return d;
}
function De(...p) {
  function d(o) {
    return typeof o == "object" && Object.prototype.toString.call(o) === "[object Object]";
  }
  let _ = arguments.length, g = arguments[0];
  d(g) || (g = {});
  for (let o = 1; o < _; o++) {
    let h = arguments[o];
    if (d(h))
      for (let P in h)
        P === "__proto__" || g === h[P] || g.hasOwnProperty(P) && (d(h[P]) ? g[P] = De(g[P], h[P]) : g[P] = h[P]);
  }
  return g;
}
function Ye(p, d) {
  let _ = {}, g = Object.getOwnPropertyNames(p), o = Object.getOwnPropertyNames(d);
  return g.length === o.length && g.forEach((h) => {
    p[h] !== d[h] && (_[h] = d[h]);
  }), _;
}
const ae = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeBatchDeteleHandler: "beforeBatchDeteleHandler",
  afterBatchDeteleHandler: "afterBatchDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Ze(p = { debug: !1 }) {
  const d = te({
    hooks: {}
  });
  return Object.keys(p).forEach((g) => {
    g !== "debug" && (d.hooks[g] = p[g]);
  }), {
    hookHandler: (g, o) => {
      let h = !1;
      try {
        p.debug && (console.group("DeBug\uFF1A", g), console.table(o.Data), console.groupEnd()), h = d.hooks[g](o);
      } catch {
        h = !0;
      }
      return h;
    }
  };
}
let w;
const de = O(), L = O({ ...xe }), i = O({ ...Oe }), x = O({ ...Xe }), el = (p) => {
  de.value = p.CrudRequest, L.value = De(xe, p), w = { ...L.value };
}, ll = (p) => {
  x.value = { ...p }, i.value = Y(Oe), al(x.value.source), L.value = De(L.value, p);
};
function he() {
  return { ...Be(L.value) };
}
function A() {
  return { ...Be(i.value) };
}
function $e() {
  return { ...Be(x.value) };
}
const Ae = () => {
  const p = (n) => {
    let r = {};
    return x.value.rowKey && (r[x.value.rowKey] = n[x.value.rowKey]), x.value.rowKeys && x.value.rowKeys.forEach((F) => {
      r[F] = n[F];
    }), r;
  }, { hookHandler: d } = Ze(x.value.hooks);
  function _() {
    i.value.tableLoading = !0;
    const n = te({ ...i.value.initSearchModel, ...i.value.searchModel });
    for (const r in n)
      typeof n[r] == "string" && (n[r] = n[r].trim(), n[r] === "" && (n[r] = void 0)), n[r] === null && (n[r] = void 0);
    !d(ae.beforeQueryHandler, { CrudState: i, Data: n }) || de.value({
      url: x.value.url,
      name: L.value.ApiName.query,
      data: {
        pagenum: L.value.Page_PageParams.current,
        pagesize: L.value.Page_PageParams.pageSize,
        ...n
      }
    }).then((r) => {
      const { data: F, page: C } = r;
      setTimeout(() => {
        g(F, n), L.value.Page_PageParams.total = C.total, i.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      i.value.tableLoading = !1;
    });
  }
  const g = (n, r) => {
    Object.keys(r).filter((C) => r[C] != null).length == 0 && (i.value.originalData = n), i.value.originalData = Y(n), d(ae.afterQueryHandler, { CrudState: i, Data: n }) && (i.value.tableData = Y(n));
  };
  function o() {
    i.value.editModel = Y(i.value.initEditModel);
    const n = te({ ...i.value.editModel });
    !d(ae.beforeAddHandler, { CrudState: i, Data: n }) || (i.value.Mode = "add", i.value.DialogVisible = !0);
  }
  const h = (n) => {
    const r = te({
      ...n
    });
    if (!d(ae.beforeEditHandler, { CrudState: i, Data: r }))
      return;
    const F = Y(r);
    Object.keys(F).forEach((C) => {
      i.value.editModel[C] = F[C], i.value.editFormValue[C] = F[C];
    }), i.value.Mode = "edit", i.value.DialogVisible = !0;
  }, P = async (n) => {
    !n || await n.validate((r) => {
      if (r) {
        const F = te({
          ...i.value.editModel
        });
        if (!d(ae.beforeSubmitHandler, { CrudState: i, Data: F }))
          return;
        i.value.Mode === "add" ? D(F) : E(F);
      }
    });
  }, D = (n) => {
    i.value.submitLoading = !0;
    let r = n;
    n.FormData instanceof FormData && (r = n.FormData), de.value({ url: x.value.url, name: L.value.ApiName.add, data: r }).then(() => {
      i.value.DialogVisible = !1, be("\u65B0\u589E\u6210\u529F"), _(), i.value.submitLoading = !1;
    }).catch(() => {
      i.value.submitLoading = !1;
    });
  }, E = (n) => {
    i.value.submitLoading = !1;
    let r = n;
    if (n.FormData instanceof FormData)
      r = n.FormData;
    else {
      const F = Ye(i.value.editFormValue, r);
      if (JSON.stringify(F) === "{}")
        return i.value.submitLoading = !1, ke({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      r = {
        ...p(n),
        ...F
      };
    }
    de.value({ url: x.value.url, name: L.value.ApiName.edit, data: r }).then(() => {
      i.value.DialogVisible = !1, be("\u7F16\u8F91\u6210\u529F"), _(), i.value.submitLoading = !1;
    }).catch(() => {
      i.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: _,
    addRecord: o,
    editRecord: h,
    handleSubmit: P,
    delFlag: (n) => {
      Ve.confirm(`\u786E\u5B9A\u8981 \u201C${n.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          ...p(n),
          deleteFlag: n.deleteFlag == 0 ? 1 : 0
        });
        !d(ae.beforedisabledHandler, { CrudState: i, Data: r }) || de.value({
          url: x.value.url,
          name: L.value.ApiName.deleteFlag,
          data: r
        }).then(() => {
          be(`\u6570\u636E${n.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), _();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (n) => {
      Ve.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          ...p(n)
        });
        !d(ae.beforeDeteleHandler, { CrudState: i, Data: r }) || de.value({
          url: x.value.url,
          name: L.value.ApiName.delete,
          data: r
        }).then(() => {
          be("\u5220\u9664\u6210\u529F"), _();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      const n = i.value.multipleSelection.map((r) => r[x.value.rowKey]);
      Ve.confirm(`\u786E\u5B9A\u8981\u5220\u9664\u8FD9 ${n.length} \u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          [x.value.rowKey]: n,
          selection: i.value.multipleSelection
        });
        !d(ae.beforeBatchDeteleHandler, { CrudState: i, Data: r }) || de.value({
          url: x.value.url,
          name: L.value.ApiName.remove,
          data: r
        }).then(() => {
          be("\u6279\u91CF\u5220\u9664\u6210\u529F"), i.value.multipleSelection = [], i.value.CompRef.TableRef.clearSelection(), _();
        });
      }).catch(() => {
      });
    }
  };
};
function ol(...p) {
  L.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...p);
}
const al = (p) => {
  const { filter: d, editor: _, column: g, columns: o } = p;
  i.value.ElementArrs = { filter: {}, editor: {}, column: {}, columns: {} };
  let h = {};
  d.forEach((D) => {
    try {
      h[D] = o[D].searchDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", D);
    }
    i.value.ElementArrs.filter[D] = o[D];
  }), i.value.initSearchModel = Y(h), i.value.searchModel = Y(i.value.initSearchModel);
  let P = {};
  _.forEach((D) => {
    try {
      P[D] = o[D].addDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", D);
    }
    i.value.ElementArrs.editor[D] = o[D];
  }), i.value.initEditModel = Y(P), g.forEach((D) => {
    i.value.ElementArrs.column[D] = o[D];
  }), i.value.ElementArrs.columns = o;
};
ve(() => {
  let p = [];
  for (const d in i.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(i.value.ElementArrs.editor, d) && i.value.ElementArrs.editor[d].type === "el-upload" && p.push(d);
  return p;
});
const be = (p, d = "success") => {
  je({
    title: p,
    type: d,
    offset: 70,
    duration: 2500
  });
}, tl = /* @__PURE__ */ ge({
  __name: "crud_SearchForm",
  setup(p) {
    const d = O(), { Form_LabelWidth: _ } = he(), {
      CompRef: g,
      searchModel: o,
      ElementArrs: {
        value: { filter: h }
      }
    } = A();
    Ce(() => {
      g.value.SearchFormRef = d.value;
    });
    const P = (E) => {
      var B, S;
      return E.range ? (B = E.formProps) != null && B.type ? E.formProps.type + "range" : "daterange" : (S = E.formProps) != null && S.type ? E.formProps.type : "date";
    }, D = (E, B, S) => {
      o.value[B] === S ? o.value[B] = void 0 : o.value[B] = E.formProps.options[S].value;
    };
    return (E, B) => {
      const S = m("el-input"), T = m("el-form-item"), n = m("el-col"), r = m("el-input-number"), F = m("el-option"), C = m("el-select"), V = m("el-date-picker"), U = m("el-time-picker"), re = m("el-radio"), Z = m("el-radio-button"), ee = m("el-radio-group"), ue = m("el-row"), W = m("el-form"), le = m("el-collapse-transition");
      return c(), b(le, null, {
        default: a(() => [
          Q("div", null, [
            R(E.$slots, "search-form", {}, void 0, !0),
            f(W, {
              ref_key: "SearchFormRef",
              ref: d,
              model: e(o),
              "label-width": e(_)
            }, {
              default: a(() => [
                f(ue, null, {
                  default: a(() => [
                    R(E.$slots, "search-form-top", {}, void 0, !0),
                    (c(!0), $(I, null, J(e(h), (s, y) => {
                      var q;
                      return c(), $(I, null, [
                        s.type === "el-input" ? (c(), b(n, {
                          key: 0,
                          span: s.span ? s.span : 6
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(S, M({
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, s.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : s.type === "el-input-number" ? (c(), b(n, {
                          key: 1,
                          span: s.span ? s.span : 6
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(r, M({
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, s.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : s.type === "el-select" ? (c(), b(n, {
                          key: 2,
                          span: s.span ? s.span : 6
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(C, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, s.formProps), {
                                  default: a(() => [
                                    (c(!0), $(I, null, J(s.formProps.options, (v) => (c(), b(F, {
                                      key: v.value,
                                      label: v.label,
                                      value: v.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : s.type === "el-date-picker" && !P(s).includes("range") ? (c(), b(n, {
                          key: 3,
                          span: s.span ? s.span : 6
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(V, M({
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, s.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : s.type === "el-date-picker" ? (c(), b(n, {
                          key: 4,
                          span: s.span ? s.span : 12
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(V, M({
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, s.formProps, {
                                  type: P(s)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : s.type === "el-time-picker" && !((q = s.formProps) != null && q.isRange) && !s.range ? (c(), b(n, {
                          key: 5,
                          span: s.span ? s.span : 6
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(U, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, s.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : s.type === "el-time-picker" ? (c(), b(n, {
                          key: 6,
                          span: s.span ? s.span : 12
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(U, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, s.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : s.type === "el-radio-group" ? (c(), b(n, {
                          key: 7,
                          span: s.span ? s.span : 6
                        }, {
                          default: a(() => [
                            f(T, {
                              label: s.label,
                              prop: y
                            }, {
                              default: a(() => [
                                f(ee, M({
                                  modelValue: e(o)[y],
                                  "onUpdate:modelValue": (v) => e(o)[y] = v
                                }, s.formProps), {
                                  default: a(() => [
                                    s.formProps.button ? N("", !0) : (c(!0), $(I, { key: 0 }, J(s.formProps.options, (v) => (c(), b(re, M({
                                      key: v.value,
                                      label: v.value,
                                      onClick: Pe((G) => D(s, y, v.value), ["prevent"])
                                    }, s.formProps), {
                                      default: a(() => [
                                        K(ne(v.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    s.formProps.button ? (c(!0), $(I, { key: 1 }, J(s.formProps.options, (v) => (c(), b(Z, M({
                                      key: v.value,
                                      label: v.value,
                                      onClick: Pe((G) => D(s, y, v.value), ["prevent"])
                                    }, s.formProps), {
                                      default: a(() => [
                                        K(ne(v.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : N("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : N("", !0)
                      ], 64);
                    }), 256)),
                    R(E.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const Me = (p, d) => {
  const _ = p.__vccOpts || p;
  for (const [g, o] of d)
    _[g] = o;
  return _;
}, nl = /* @__PURE__ */ Me(tl, [["__scopeId", "data-v-394e11ba"]]), rl = { class: "edit" }, ul = { class: "edit_form" }, sl = /* @__PURE__ */ ge({
  __name: "crud_EditForm",
  props: {
    height: Number
  },
  setup(p) {
    const d = O(), { Form_LabelWidth: _ } = he(), { CompRef: g, editModel: o, Mode: h, ElementArrs: P, uploadFiles: D } = A();
    Ce(() => {
      g.value.EditFormRef = d.value;
    });
    const E = ve(() => {
      let r = {};
      const F = $e().source.value.editor, C = P.value.editor;
      return F.forEach((V) => {
        C[V].visible && typeof C[V].visible == "function" ? C[V].visible(A(), h.value) && (r[V] = C[V]) : r[V] = C[V];
      }), r;
    }), B = ({ showFileList: r }) => {
      if (r)
        return !1;
      if (D.value[0])
        return URL.createObjectURL(D.value[0]);
    }, S = (r) => typeof r.disabled == "function" ? r.disabled(A(), h.value) : !1, T = (r) => {
      let F = { ...r };
      return Object.keys(F).forEach((C) => {
        typeof F[C] == "function" && (F[C] = F[C].bind(this, A()));
      }), F;
    }, n = (r, F, C) => {
      o.value[F] === C ? o.value[F] = void 0 : o.value[F] = r.formProps.options[C].value;
    };
    return (r, F) => {
      const C = m("el-input"), V = m("el-form-item"), U = m("el-col"), re = m("el-input-number"), Z = m("el-option"), ee = m("el-select"), ue = m("el-date-picker"), W = m("el-time-picker"), le = m("el-cascader"), s = m("el-button"), y = m("el-image"), q = m("plus"), v = m("el-icon"), G = m("el-upload"), ce = m("el-radio"), pe = m("el-radio-button"), fe = m("el-radio-group"), _e = m("el-row"), me = m("el-form"), k = m("el-scrollbar");
      return c(), $("div", rl, [
        f(k, {
          height: p.height,
          "max-height": p.height
        }, {
          default: a(() => [
            Q("div", ul, [
              R(r.$slots, "edit-form", { editModel: e(o) }, void 0, !0),
              f(me, {
                ref_key: "EditFormRef",
                ref: d,
                model: e(o),
                "label-width": e(_)
              }, {
                default: a(() => [
                  f(_e, null, {
                    default: a(() => [
                      R(r.$slots, "edit-form-top", { editModel: e(o) }, void 0, !0),
                      (c(!0), $(I, null, J(e(E), (l, t) => (c(), $(I, { key: t }, [
                        l.type === "el-input" ? (c(), b(U, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(C, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[t],
                                  "onUpdate:modelValue": (u) => e(o)[t] = u,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: S(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (c(), b(U, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(re, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[t],
                                  "onUpdate:modelValue": (u) => e(o)[t] = u,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: S(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (c(), b(U, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(ee, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[t],
                                  "onUpdate:modelValue": (u) => e(o)[t] = u,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: S(l)
                                }, l.formProps), {
                                  default: a(() => [
                                    (c(!0), $(I, null, J(l.formProps.options, (u) => (c(), b(Z, {
                                      key: u.value,
                                      label: u.label,
                                      value: u.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (c(), b(U, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(ue, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[t],
                                  "onUpdate:modelValue": (u) => e(o)[t] = u,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: S(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (c(), b(U, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(W, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[t],
                                  "onUpdate:modelValue": (u) => e(o)[t] = u,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: S(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (c(), b(U, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(le, M({
                                  style: { width: "100%" },
                                  modelValue: e(o)[t],
                                  "onUpdate:modelValue": (u) => e(o)[t] = u,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: S(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (c(), b(U, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(G, M({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: t + "UploadRef",
                                  action: ""
                                }, T(l.formProps)), {
                                  default: a(() => {
                                    var u;
                                    return [
                                      ((u = l.formProps) == null ? void 0 : u.listType) !== "picture-card" ? (c(), b(s, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: a(() => [
                                          K(ne(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : N("", !0),
                                      l.formProps.listType === "picture-card" && B(l.formProps) ? (c(), b(y, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: B(l.formProps)
                                      }, null, 8, ["src"])) : N("", !0),
                                      l.formProps.listType == "picture-card" && !B(l.formProps) ? (c(), b(v, { key: 2 }, {
                                        default: a(() => [
                                          f(q)
                                        ]),
                                        _: 1
                                      })) : N("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (c(), b(U, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            f(V, {
                              label: l.label,
                              prop: t,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                f(fe, M({
                                  modelValue: e(o)[t],
                                  "onUpdate:modelValue": (u) => e(o)[t] = u,
                                  disabled: S(l)
                                }, l.formProps), {
                                  default: a(() => [
                                    l.formProps.button ? N("", !0) : (c(!0), $(I, { key: 0 }, J(l.formProps.options, (u) => (c(), b(ce, M({
                                      key: u.value,
                                      label: u.value,
                                      onClick: Pe((j) => n(l, t, u.value), ["prevent"])
                                    }, l.formProps), {
                                      default: a(() => [
                                        K(ne(u.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    l.formProps.button ? (c(!0), $(I, { key: 1 }, J(l.formProps.options, (u) => (c(), b(pe, M({
                                      key: u.value,
                                      label: u.value,
                                      onClick: Pe((j) => n(l, t, u.value), ["prevent"])
                                    }, l.formProps), {
                                      default: a(() => [
                                        K(ne(u.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : N("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : N("", !0)
                      ], 64))), 128)),
                      R(r.$slots, "edit-form-bottom", { editModel: e(o) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const dl = /* @__PURE__ */ Me(sl, [["__scopeId", "data-v-ef911526"]]), il = { key: 1 }, cl = /* @__PURE__ */ ge({
  __name: "crud_Table",
  props: { height: Number },
  emits: ["row-contextmenu"],
  setup(p, { emit: d }) {
    const _ = O(), { Table_isOpenMultipleSelection: g, Table_isOpenIndex: o, Table_isOpenExpand: h, Table_ExpandColumn: P, Table_MenuAlign: D, Table_IsShowMenu: E, Table_MenuWidth: B, Page_PageParams: S, Permission: T, Permissions: n } = he(), {
      CompRef: r,
      tableData: F,
      tableLoading: C,
      ElementArrs: {
        value: { filter: V, column: U, columns: re }
      },
      searchModel: Z,
      multipleSelection: ee
    } = A(), { rowKey: ue, keyName: W, Table_Attributes: le } = $e(), { queryRecord: s, editRecord: y, delFlag: q, deleteRecord: v } = Ae();
    Ce(() => {
      r.value.TableRef = _.value;
    });
    const G = ve(() => (S.value.current - 1) * S.value.pageSize + 1), ce = (k) => {
      ee.value = k;
    }, pe = (k, l, t, u) => {
      l.label && navigator.clipboard.writeText(t.innerText).then(() => {
        ke.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, fe = (k, l, t) => {
      t.preventDefault(), d("row-contextmenu", { row: k, column: l, event: t }, A());
    }, _e = (k, l, t) => {
      if (l.formProps && l.formProps.options) {
        const u = l.formProps.options.findIndex((j) => j.value == k[t]);
        return u === -1 ? k[t] : l.formProps.options[u].label;
      } else
        return k[t];
    }, me = (k, l) => {
      let t = { ...k };
      return Object.keys(t).forEach((u) => {
        typeof t[u] == "function" && (t[u] = t[u].call(this, A(), l));
      }), t;
    };
    return (k, l) => {
      const t = m("el-empty"), u = m("el-table-column"), j = m("el-descriptions-item"), Fe = m("el-descriptions"), ye = m("el-input"), z = m("el-button"), Ue = m("el-table"), Ee = Se("Auth"), Le = Se("loading");
      return ie((c(), b(Ue, M({
        ref_key: "TableRef",
        ref: _,
        data: e(F),
        "row-key": e(ue),
        height: p.height,
        onCellDblclick: pe,
        onSelectionChange: ce,
        onRowContextmenu: fe
      }, e(le)), {
        empty: a(() => [
          f(t, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: a(() => [
          e(g) ? (c(), b(u, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : N("", !0),
          e(h) ? (c(), b(u, {
            key: 1,
            type: "expand",
            width: 35
          }, {
            default: a(({ row: H }) => [
              f(Fe, {
                column: e(P),
                border: ""
              }, {
                default: a(() => [
                  (c(!0), $(I, null, J(e(re), (X, se) => (c(), $(I, { key: se }, [
                    X.hidden ? N("", !0) : (c(), b(j, {
                      key: 0,
                      label: X.label
                    }, {
                      default: a(() => [
                        K(ne(_e(H, X, se)), 1)
                      ]),
                      _: 2
                    }, 1032, ["label"]))
                  ], 64))), 128))
                ]),
                _: 2
              }, 1032, ["column"])
            ]),
            _: 1
          })) : N("", !0),
          e(o) ? (c(), b(u, {
            key: 2,
            label: "###",
            width: 55,
            align: "right",
            "show-overflow-tooltip": ""
          }, {
            default: a(({ $index: H }) => [
              K(ne(e(G) + H), 1)
            ]),
            _: 1
          })) : N("", !0),
          (c(!0), $(I, null, J(e(U), (H, X) => (c(), b(u, M({
            key: X,
            align: H.align || "left",
            label: H.label,
            prop: X
          }, H.tableProps, { "show-overflow-tooltip": "" }), Te({ _: 2 }, [
            H.columnSlot ? {
              name: "default",
              fn: a((se) => [
                (c(), b(Ne(H.columnSlot.is), ze(Ie(me(H.columnSlot, se))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128)),
          R(k.$slots, "table-column"),
          e(E) ? (c(), b(u, {
            key: 3,
            align: e(D) || "left",
            width: e(B)
          }, {
            header: a(() => [
              e(W) ? (c(), b(ye, {
                key: 0,
                modelValue: e(Z)[e(W)],
                "onUpdate:modelValue": l[0] || (l[0] = (H) => e(Z)[e(W)] = H),
                placeholder: e(V)[e(W)].label + "\u6A21\u7CCA\u67E5\u627E",
                clearable: "",
                onKeyup: Ke(e(s), ["enter", "native"])
              }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : (c(), $("span", il, "\u64CD\u4F5C"))
            ]),
            default: a((H) => {
              var X, se, Re;
              return [
                R(k.$slots, "menu-top", { scope: H }),
                ie((c(), b(z, {
                  plain: "",
                  type: H.row[e(T).deleteFlag] ? "danger" : "success",
                  onClick: (He) => e(q)(H.row)
                }, {
                  default: a(() => [
                    K(ne(H.row[e(T).deleteFlag] ? "\u7981\u7528" : "\u542F\u7528"), 1)
                  ]),
                  _: 2
                }, 1032, ["type", "onClick"])), [
                  [Ee, { Permissions: e(n), access: [(X = e(T)) == null ? void 0 : X.deleteFlag] }]
                ]),
                ie(f(z, {
                  plain: "",
                  type: "primary",
                  icon: "edit",
                  onClick: (He) => e(y)(H.row)
                }, null, 8, ["onClick"]), [
                  [Ee, { Permissions: e(n), access: [(se = e(T)) == null ? void 0 : se.edit] }]
                ]),
                ie(f(z, {
                  plain: "",
                  type: "danger",
                  icon: "delete",
                  onClick: (He) => e(v)(H.row)
                }, null, 8, ["onClick"]), [
                  [Ee, { Permissions: e(n), access: [(Re = e(T)) == null ? void 0 : Re.delete] }]
                ]),
                R(k.$slots, "menu-bottom", { scope: H })
              ];
            }),
            _: 3
          }, 8, ["align", "width"])) : N("", !0)
        ]),
        _: 3
      }, 16, ["data", "row-key", "height"])), [
        [Le, e(C)]
      ]);
    };
  }
}), pl = /* @__PURE__ */ ge({
  __name: "crud_Pagination",
  setup(p) {
    const { Page_PageSizes: d, Page_PageParams: _, Page_Layout: g, Page_isHideOnSinglePage: o } = he(), { queryRecord: h } = Ae(), P = (E) => {
      _.value.pageSize = E, h();
    }, D = (E) => {
      _.value.current = E, _.value.current != null && h();
    };
    return (E, B) => {
      const S = m("el-pagination");
      return c(), b(S, {
        "hide-on-single-page": e(o),
        "current-page": e(_).current,
        "page-size": e(_).pageSize,
        "page-sizes": e(d),
        background: "",
        layout: e(g),
        total: e(_).total,
        onSizeChange: P,
        onCurrentChange: D
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), fl = { style: { padding: "20px", "background-color": "#fff", "border-radius": "20px" } }, _l = { class: "butSlotDiv" }, ml = { class: "button_left" }, bl = /* @__PURE__ */ K(" \u65B0\u589E "), vl = /* @__PURE__ */ K(" \u6279\u91CF\u5220\u9664 "), gl = { class: "button_right" }, hl = { style: { display: "flex", "justify-content": "flex-end" } }, Fl = /* @__PURE__ */ K("\u53D6\u6D88"), yl = /* @__PURE__ */ K("\u91CD\u7F6E"), Pl = /* @__PURE__ */ K("\u63D0\u4EA4"), Cl = /* @__PURE__ */ ge({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    debug: { type: Boolean, default: () => w.debug },
    mainMaxHeight: { default: () => w.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => w.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => w.isOpenSearchForm },
    Form_LabelWidth: { default: () => w.Form_LabelWidth },
    Dialog_Width: { default: () => w.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => w.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => w.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => w.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => w.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => w.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => w.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => w.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => w.Table_ExpandColumn },
    Table_IsShowMenu: { type: Boolean, default: () => w.Table_IsShowMenu },
    Table_MenuWidth: { default: () => w.Table_MenuWidth },
    Page_PageSizes: { default: () => w.Page_PageSizes },
    Page_PageParams: { default: () => w.Page_PageParams },
    Page_Layout: { default: () => w.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => w.Page_isHideOnSinglePage },
    ApiName: { default: () => w.ApiName },
    Permission: { default: () => w.Permission },
    Permissions: { default: () => w.Permissions }
  },
  emits: ["row-contextmenu"],
  setup(p, { expose: d, emit: _ }) {
    const g = p, o = Ge();
    ll(g);
    const { queryRecord: h, addRecord: P, handleSubmit: D, deleteMulRecord: E } = Ae(), { CompRef: B, initSearchModel: S, Mode: T, DialogVisible: n, multipleSelection: r, submitLoading: F, DialogVisibleFooterButton: C } = A(), { isOpenSearchForm: V, isAfterMountQuery: U, Table_isOpenMultipleSelection: re, Dialog_Width: Z, Dialog_isFullscreen: ee, Dialog_isCloseOnPressEscape: ue, Dialog_isCloseOnClickModal: W, Permission: le, Permissions: s } = he();
    if (o.params.data) {
      ol("\u8DEF\u7531\u4F20\u53C2\uFF1A", o.params.data);
      let t = o.params.data, u = JSON.parse(t);
      S.value = De(S.value, u);
    }
    const y = O(), q = O(), v = O(), G = O(), ce = O(0), pe = O(0), fe = O(0), _e = O(0);
    Ce(() => {
      B.value.containerDivRef = y.value, B.value.searchDivRef = q.value, B.value.buttonDivRef = v.value, B.value.paginationDivRef = G.value, ce.value = y.value.offsetHeight - 40, pe.value = q.value.offsetHeight, fe.value = v.value.offsetHeight, _e.value = G.value.offsetHeight, U.value && h();
    });
    const me = ve(() => {
      const t = O(ce.value - fe.value - _e.value);
      return V.value ? t.value - pe.value : t.value;
    }), k = ve(() => {
      const t = O(document.documentElement.clientHeight);
      return ee.value ? t.value - 54 - 62 - 2 : t.value - 54 - 62 - 2 - t.value * 0.15 - 50;
    }), l = ({ row: t, event: u }, j) => {
      _("row-contextmenu", { row: t, event: u }, j);
    };
    return d({
      ...A()
    }), (t, u) => {
      var Fe, ye;
      const j = Se("Auth");
      return c(), $("div", {
        ref_key: "containerDivRef",
        ref: y,
        style: { height: "100%" }
      }, [
        Q("div", fl, [
          Q("div", {
            ref_key: "searchDivRef",
            ref: q
          }, [
            ie(f(nl, null, {
              "search-form": a(() => [
                R(t.$slots, "search-form", {
                  CrudState: e(A)()
                }, void 0, !0)
              ]),
              "search-form-top": a(() => [
                R(t.$slots, "search-form-top", {
                  CrudState: e(A)()
                }, void 0, !0)
              ]),
              "search-form-bottom": a(() => [
                R(t.$slots, "search-form-bottom", {
                  CrudState: e(A)()
                }, void 0, !0)
              ]),
              _: 3
            }, 512), [
              [We, e(V)]
            ])
          ], 512),
          Q("div", {
            ref_key: "buttonDivRef",
            ref: v,
            class: "buttonDiv"
          }, [
            Q("div", _l, [
              Q("div", ml, [
                ie((c(), b(e(oe), {
                  type: "primary",
                  icon: "plus",
                  onClick: e(P)
                }, {
                  default: a(() => [
                    bl
                  ]),
                  _: 1
                }, 8, ["onClick"])), [
                  [j, { Permissions: e(s), access: [(Fe = e(le)) == null ? void 0 : Fe.add] }]
                ]),
                e(re) ? ie((c(), b(e(oe), {
                  key: 0,
                  disabled: e(r).length <= 0,
                  type: "danger",
                  icon: "delete",
                  onClick: e(E)
                }, {
                  default: a(() => [
                    vl
                  ]),
                  _: 1
                }, 8, ["disabled", "onClick"])), [
                  [j, { Permissions: e(s), access: [(ye = e(le)) == null ? void 0 : ye.remove] }]
                ]) : N("", !0),
                R(t.$slots, "button-left", {
                  CrudState: e(A)()
                }, void 0, !0)
              ]),
              Q("div", gl, [
                R(t.$slots, "button-right", {
                  CrudState: e(A)()
                }, void 0, !0)
              ])
            ]),
            f(e(Qe), { style: { "flex-shrink": "0", width: "150px" } }, {
              default: a(() => [
                f(e(oe), {
                  color: "#67c23a",
                  icon: "search",
                  onClick: e(h)
                }, null, 8, ["onClick"]),
                f(e(oe), {
                  color: "#e6a23c",
                  icon: "refresh",
                  onClick: u[0] || (u[0] = (z) => e(B).SearchFormRef.resetFields())
                }),
                f(e(oe), {
                  color: "#409eff",
                  icon: "expand",
                  onClick: u[1] || (u[1] = (z) => V.value = !e(V))
                })
              ]),
              _: 1
            })
          ], 512),
          f(cl, {
            height: e(me),
            onRowContextmenu: l
          }, {
            "table-column": a(() => [
              R(t.$slots, "table-column", {
                CrudState: e(A)()
              }, void 0, !0)
            ]),
            "menu-top": a(({ scope: z }) => [
              R(t.$slots, "menu-top", {
                scope: z,
                CrudState: e(A)()
              }, void 0, !0)
            ]),
            "menu-bottom": a(({ scope: z }) => [
              R(t.$slots, "menu-bottom", {
                scope: z,
                CrudState: e(A)()
              }, void 0, !0)
            ]),
            _: 3
          }, 8, ["height"]),
          Q("div", {
            ref_key: "paginationDivRef",
            ref: G,
            style: { "padding-top": "20px" }
          }, [
            f(pl)
          ], 512),
          f(e(Je), {
            class: "DialogVisible",
            modelValue: e(n),
            "onUpdate:modelValue": u[5] || (u[5] = (z) => qe(n) ? n.value = z : null),
            title: e(T) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: e(Z),
            "destroy-on-close": "",
            "close-on-press-escape": e(ue),
            fullscreen: e(ee),
            "close-on-click-modal": e(W)
          }, Te({
            default: a(() => [
              f(dl, { height: e(k) }, {
                "edit-form": a(() => [
                  R(t.$slots, "edit-form", {
                    CrudState: e(A)()
                  }, void 0, !0)
                ]),
                "edit-form-top": a(() => [
                  R(t.$slots, "edit-form-top", {
                    CrudState: e(A)()
                  }, void 0, !0)
                ]),
                "edit-form-bottom": a(() => [
                  R(t.$slots, "edit-form-bottom", {
                    CrudState: e(A)()
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["height"])
            ]),
            _: 2
          }, [
            e(C) ? {
              name: "footer",
              fn: a(() => [
                Q("div", hl, [
                  R(t.$slots, "edit-form-footer", {
                    CrudState: e(A)()
                  }, void 0, !0),
                  f(e(oe), {
                    onClick: u[2] || (u[2] = (z) => n.value = !1)
                  }, {
                    default: a(() => [
                      Fl
                    ]),
                    _: 1
                  }),
                  f(e(oe), {
                    type: "warning",
                    plain: "",
                    onClick: u[3] || (u[3] = (z) => e(B).EditFormRef.resetFields())
                  }, {
                    default: a(() => [
                      yl
                    ]),
                    _: 1
                  }),
                  f(e(oe), {
                    type: "primary",
                    loading: e(F),
                    onClick: u[4] || (u[4] = (z) => e(D)(e(B).EditFormRef))
                  }, {
                    default: a(() => [
                      Pl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ])
      ], 512);
    };
  }
});
const we = /* @__PURE__ */ Me(Cl, [["__scopeId", "data-v-50401992"]]), Dl = {
  mounted(p, d, _) {
    const g = d.value.Permissions, o = d.value.access;
    let h = !1;
    for (let P = 0; P < o.length; P++)
      g.includes(o[P]) && (h = !0);
    h || p.parentNode && p.parentNode.removeChild(p);
  }
};
we.install = (p) => {
  p.component("CrudEl", we), p.directive("Auth", Dl);
};
const wl = (p, d) => {
  d ? (d.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), el(d), p.use(we)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  De as DataMerger,
  Y as DeepClone,
  el as InitSys,
  wl as createCrudEl,
  ae as hooksName,
  Ye as isObjEqual,
  Ze as useHooks
};
